## openblas 0.3.5+ds

=== lapack/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR})


set(LAPACK_SOURCES
  getrf/getrf_single.c
  potrf/potrf_U_single.c
  potrf/potrf_L_single.c
  lauum/lauum_U_single.c
  lauum/lauum_L_single.c
)

# add a 'z' to filename for complex version
set(LAPACK_MANGLED_SOURCES
  getf2/getf2_k.c
  lauu2/lauu2_U.c
  lauu2/lauu2_L.c
  potf2/potf2_U.c
  potf2/potf2_L.c
)

# sources that need TRANS set
# this has a 'z' version
set(TRANS_SOURCES
  getrs/getrs_single.c
)

# sources that need UNIT set
# these do NOT have a z version
set(UNIT_SOURCES
  trtri/trtri_U_single.c
  trtri/trtri_L_single.c
)

# these have a 'z' version
set(UNIT_SOURCES2
  trti2/trti2_U.c
  trti2/trti2_L.c
)

GenerateNamedObjects("${LAPACK_SOURCES}")
GenerateNamedObjects("${LAPACK_MANGLED_SOURCES}" "" "" false "" "" false 3)

GenerateNamedObjects("laswp/generic/laswp_k_4.c" "" "laswp_plus" false "" ""  false 3)
GenerateNamedObjects("laswp/generic/laswp_k_4.c" "MINUS" "laswp_minus" false "" ""  false 3)

# dynamic_arch laswp needs arch specific code ?
#foreach(TARGET_CORE ${DYNAMIC_CORE})
#      set(TSUFFIX "_${TARGET_CORE}")
#
#GenerateNamedObjects("laswp/generic/laswp_k_4.c" "" "laswp_plus" false "" ${TSUFFIX}  false 3)
#GenerateNamedObjects("laswp/generic/laswp_k_4.c" "MINUS" "laswp_minus" false "" ${TSUFFIX}  false 3)
#endforeach ()

if (USE_THREAD)

  if (USE_OPENMP)
    set(GETRF_SRC getrf/getrf_parallel_omp.c)
  else ()
    set(GETRF_SRC getrf/getrf_parallel.c)
  endif ()

  # these do not have 'z' versions
  set(PARALLEL_SOURCES
    ${GETRF_SRC}
    lauum/lauum_U_parallel.c
    lauum/lauum_L_parallel.c
    potrf/potrf_U_parallel.c
    potrf/potrf_L_parallel.c
  )

  # this has a z version
  list(APPEND TRANS_SOURCES
    getrs/getrs_parallel.c
  )

  # these do NOT have a z version
  list(APPEND UNIT_SOURCES
    trtri/trtri_U_parallel.c
    trtri/trtri_L_parallel.c
  )

  GenerateNamedObjects("${PARALLEL_SOURCES}")
endif ()

foreach (float_type ${FLOAT_TYPES})
  if (${float_type} STREQUAL "COMPLEX" OR ${float_type} STREQUAL "ZCOMPLEX")
    foreach (trans_src ${TRANS_SOURCES})
      string(REGEX MATCH "[a-z]/([a-z]+_)([a-z]+)" op_name ${trans_src})
      string(REPLACE "/" "/z" ztrans_src ${trans_src})
      GenerateNamedObjects("${ztrans_src}" "TRANS=1" "${CMAKE_MATCH_1}N_${CMAKE_MATCH_2}" false "" "" false ${float_type})
      GenerateNamedObjects("${ztrans_src}" "TRANS=2" "${CMAKE_MATCH_1}T_${CMAKE_MATCH_2}" false "" "" false ${float_type})
      GenerateNamedObjects("${ztrans_src}" "TRANS=3" "${CMAKE_MATCH_1}R_${CMAKE_MATCH_2}" false "" "" false ${float_type})
      GenerateNamedObjects("${ztrans_src}" "TRANS=4" "${CMAKE_MATCH_1}C_${CMAKE_MATCH_2}" false "" "" false ${float_type})
    endforeach ()
  else ()
    GenerateCombinationObjects("${TRANS_SOURCES}" "TRANS" "N" "" 4 "" false ${float_type})
  endif ()
endforeach ()

GenerateCombinationObjects("${UNIT_SOURCES}" "UNIT" "N" "" 4)
GenerateCombinationObjects("${UNIT_SOURCES2}" "UNIT" "N" "" 0 "" "" 3)

add_library(lapack OBJECT ${OPENBLAS_SRC})

=== utest/Makefile ===
UTEST_CHECK = 1
TOPDIR	= ..

UTESTBIN=openblas_utest

.PHONY : all
.NOTPARALLEL : all run_test $(UTESTBIN)

include $(TOPDIR)/Makefile.system

OBJS=utest_main.o test_amax.o test_rotmg.o test_axpy.o test_dotu.o test_dsdot.o test_swap.o test_rot.o
#test_rot.o test_swap.o test_axpy.o test_dotu.o test_dsdot.o test_fork.o

ifneq ($(NO_LAPACK), 1)
OBJS += test_potrs.o
endif

#this does not work with OpenMP nor with native Windows or Android threads
# FIXME TBD if this works on OSX, SunOS, POWER and zarch
ifndef USE_OPENMP
ifeq ($(OSNAME), $(filter $(OSNAME),Linux CYGWIN_NT))
OBJS += test_fork.o
endif
endif

all : run_test

$(UTESTBIN): $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ ../$(LIBNAME) $(EXTRALIB) $(FEXTRALIB)

run_test: $(UTESTBIN)
ifndef CROSS
	./$(UTESTBIN)
endif

clean:
	-rm -f *.o $(UTESTBIN)

libs:

=== debian/changelog ===
openblas (0.3.5+ds-3) unstable; urgency=medium

  * Fix FTBFS when CPU of the build machine is not detected (amd64, arm64, i386)
    - pass TARGET=GENERIC when building with DYNAMIC_ARCH=1
    - target-generic.patch: new patch taken from upstream, makes the above
      possible
    (Closes: #923607)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 11 Mar 2019 10:18:39 +0100

openblas (0.3.5+ds-2) unstable; urgency=medium

  * skylakex-dgemm.patch: new patch, fixes DGEMM regression on SkylakeX.
    Thanks to Mo Zhou (Closes: #921698)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 09 Feb 2019 10:38:22 +0100

openblas (0.3.5+ds-1) unstable; urgency=medium

  * New upstream version 0.3.5+ds
  * Bump S-V to 4.3.0

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 04 Jan 2019 10:28:31 +0100

openblas (0.3.4+ds-1) unstable; urgency=medium

  * New upstream version 0.3.4+ds
  * d/copyright: reflect upstream changes
  * Dynamic kernel selection is now implemented on arm64
  * Switch to new way of specifying debhelper compat level
  * Increase priority in alternatives system to 100 (Closes: #911131)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 07 Dec 2018 15:49:27 +0100

=== debian/control ===
Source: openblas
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 11),
               dh-exec,
               gfortran,
               liblapack-pic (>= 3.7.1-2~)
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/openblas
Vcs-Git: https://salsa.debian.org/science-team/openblas.git
Homepage: https://github.com/xianyi/OpenBLAS
Rules-Requires-Root: no

Package: libopenblas-base
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared library)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to
 the best architecture at run time (only on amd64, arm64 and i386).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian

Package: libopenblas-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas-base (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (development files)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to
 the best architecture at run time (only on amd64, arm64 and i386).
 .
 This package includes the static libraries and symbolic links
 needed for program development.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

MAKE_OPTIONS := NO_LAPACKE=1 NO_AFFINITY=1 USE_OPENMP=0 NO_WARMUP=1 CFLAGS="$(CPPFLAGS) $(CFLAGS)" FFLAGS="$(FFLAGS)"

# Avoid having -O2 automatically added (especially for DEB_BUILD_OPTIONS=noopt)
MAKE_OPTIONS += COMMON_OPT= FCOMMON_OPT=-frecursive

# Build generic package with hardcoded max number of threads of 64
GENERIC_OPTIONS := NUM_THREADS=64

# On x86 and arm64 archs, enable dynamic arch selection
# TARGET=GENERIC is needed to avoid FTBFS when CPU detectin fails (see #923607)
ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386
ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
	GENERIC_OPTIONS += DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 TARGET=GENERIC
endif

# For other archs, there is no dynamic arch selection. To avoid selecting a
# target based on the buildd hardware, we enforce a generic-enough target.

# We cannot use the ARMv7 profile on armhf, because it requires a 32-register FP unit.
# See kernel/arm/KERNEL.ARMv7: it loads some *_vfpv3.S files, which use 32 registers.
# Also, it FTBFS if GCC flag -mvfpv3 is removed (see arm-gcc-flags.patch), because GCC
# refuses asm files with 32 FP registers in that case.
# Issue discussed in https://github.com/xianyi/OpenBLAS/issues/388
# See also debian/patches/arm-gcc-flags.patch which is related.
ifeq ($(DEB_HOST_ARCH),armhf)
	GENERIC_OPTIONS += TARGET=ARMV6
endif

ifeq ($(DEB_HOST_ARCH),powerpc)
	GENERIC_OPTIONS += TARGET=PPCG4
endif

ifeq ($(DEB_HOST_ARCH),mips64el)
	GENERIC_OPTIONS += TARGET=SICORTEX
endif

# POWER6 is the most generic arch that compiles on ppc64
ifeq ($(DEB_HOST_ARCH),ppc64)
	GENERIC_OPTIONS += TARGET=POWER6
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
	GENERIC_OPTIONS += TARGET=POWER8
endif

ifeq ($(DEB_HOST_ARCH),sparc64)
	GENERIC_OPTIONS += TARGET=SPARC
endif

ifeq ($(DEB_HOST_ARCH),s390x)
	GENERIC_OPTIONS += TARGET=ZARCH_GENERIC
endif


ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
	# Generic package
	MAKE_OPTIONS += $(GENERIC_OPTIONS)
else
	# Custom package: leave the arch detection to OpenBLAS, and optimize for the current CPU
	export DEB_CFLAGS_MAINT_APPEND := -march=native -mtune=native
	export DEB_FFLAGS_MAINT_APPEND := -march=native -mtune=native
endif


%:
	dh $@

override_dh_auto_build:
	$(MAKE) $(MAKE_OPTIONS)

	$(MAKE) -C interface shared-blas-lapack $(MAKE_OPTIONS)

override_dh_auto_install:
	$(MAKE) install $(MAKE_OPTIONS) DESTDIR=debian/tmp/ PREFIX=/usr OPENBLAS_INCLUDE_DIR=/usr/include/$(DEB_HOST_MULTIARCH) OPENBLAS_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/cblas.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/cblas-openblas.h

# We want packages linked with -lblas to depend on any BLAS alternative, and we
# want packages linked with -lopenblas to depend specifically on
# libopenblas-base.
#
# Such a setting is not supported by dh_makeshlibs, so we ship a hand-crafted
# shlibs file.
override_dh_makeshlibs:
	dh_makeshlibs
	cp debian/libopenblas-base.shlibs debian/libopenblas-base/DEBIAN/shlibs

GENERATED_DEBIAN_FILES := $(patsubst %.in,%,$(wildcard debian/*.pc.in debian/*.postinst.in debian/*.prerm.in))

$(GENERATED_DEBIAN_FILES): %: %.in
	sed -e "s/@DEB_VERSION_UPSTREAM@/$(DEB_VERSION_UPSTREAM)/g" \
	    -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" < $< > $@

override_dh_install: $(GENERATED_DEBIAN_FILES)
	dh_install

override_dh_clean:
	dh_clean
	rm -f $(GENERATED_DEBIAN_FILES)

=== debian/tests/control ===
Tests: upstream-testsuite
Restrictions: allow-stderr
Depends: @, gfortran

## openblas 0.3.6+ds

=== debian/changelog ===
openblas (0.3.6+ds-1) unstable; urgency=medium

  * New upstream version 0.3.6+ds
  * Remove patches applied upstream
    + skylakex-dgemm.patch
    + target-generic.patch
  * Enable dynamic arch selection on ppc64el and ppc64
  * Bump S-V to 4.4.0
  * Bump debhelper compat level to 12

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 08 Jul 2019 14:24:15 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Uploaders: Sébastien Villemot <sebastien@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper-compat (= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-exec,
                gfortran,
                liblapack-pic (>= 3.7.1-2~)
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/science-team/openblas
 Vcs-Git: https://salsa.debian.org/science-team/openblas.git
 Homepage: https://github.com/xianyi/OpenBLAS
@@ -30,8 +30,8 @@
  .
  Unlike Atlas, OpenBLAS provides a multiple architecture library.
  .
- All kernel will be included in the library and dynamically switched to
- the best architecture at run time (only on amd64, arm64 and i386).
+ All kernel will be included in the library and dynamically switched to the
+ best architecture at run time (only on amd64, arm64, i386, ppc64el and ppc64).
  .
  For more information on how to rebuild locally OpenBLAS, see the section:
  "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian

=== debian/rules ===
--- 
+++ 
@@ -11,9 +11,9 @@
 # Build generic package with hardcoded max number of threads of 64
 GENERIC_OPTIONS := NUM_THREADS=64
 
-# On x86 and arm64 archs, enable dynamic arch selection
-# TARGET=GENERIC is needed to avoid FTBFS when CPU detectin fails (see #923607)
-ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386
+# Architectures with dynamic arch selection
+# TARGET=GENERIC is needed to avoid FTBFS when CPU detection fails (see #923607)
+ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64 ppc64el
 ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
 	GENERIC_OPTIONS += DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 TARGET=GENERIC
 endif
@@ -31,21 +31,14 @@
 	GENERIC_OPTIONS += TARGET=ARMV6
 endif
 
+# We do not use DYNAMIC_ARCH selection on powerpc because it only works for
+# POWER6 and above
 ifeq ($(DEB_HOST_ARCH),powerpc)
 	GENERIC_OPTIONS += TARGET=PPCG4
 endif
 
 ifeq ($(DEB_HOST_ARCH),mips64el)
 	GENERIC_OPTIONS += TARGET=SICORTEX
-endif
-
-# POWER6 is the most generic arch that compiles on ppc64
-ifeq ($(DEB_HOST_ARCH),ppc64)
-	GENERIC_OPTIONS += TARGET=POWER6
-endif
-
-ifeq ($(DEB_HOST_ARCH),ppc64el)
-	GENERIC_OPTIONS += TARGET=POWER8
 endif
 
 ifeq ($(DEB_HOST_ARCH),sparc64)

## openblas 0.3.7+ds

=== debian/changelog ===
openblas (0.3.7+ds-1) unstable; urgency=medium

  * Revert dynamic arch selection on ppc64, it FTBFS
  * New upstream version 0.3.7+ds
  * dgemm-test-without-lapacke.patch: new patch taken from upstream.
    Required to avoid FTBFS.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 20 Aug 2019 17:52:34 +0200

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
  Unlike Atlas, OpenBLAS provides a multiple architecture library.
  .
  All kernel will be included in the library and dynamically switched to the
- best architecture at run time (only on amd64, arm64, i386, ppc64el and ppc64).
+ best architecture at run time (only on amd64, arm64, i386 and ppc64el).
  .
  For more information on how to rebuild locally OpenBLAS, see the section:
  "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 # Architectures with dynamic arch selection
 # TARGET=GENERIC is needed to avoid FTBFS when CPU detection fails (see #923607)
-ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64 ppc64el
+ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64el
 ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
 	GENERIC_OPTIONS += DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 TARGET=GENERIC
 endif
@@ -35,6 +35,13 @@
 # POWER6 and above
 ifeq ($(DEB_HOST_ARCH),powerpc)
 	GENERIC_OPTIONS += TARGET=PPCG4
+endif
+
+# We do not use DYNAMIC_ARCH selection on ppc64 because it fails to build.
+# See https://buildd.debian.org/status/fetch.php?pkg=openblas&arch=ppc64&ver=0.3.6%2Bds-1&stamp=1562602383&raw=0
+# POWER6 is the most generic arch that compiles on ppc64
+ifeq ($(DEB_HOST_ARCH),ppc64)
+	GENERIC_OPTIONS += TARGET=POWER6
 endif
 
 ifeq ($(DEB_HOST_ARCH),mips64el)

## openblas 0.3.8%2Bds

=== utest/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR})

if (MSVC AND "${CMAKE_C_COMPILER_ID}" MATCHES Clang)
  set(OpenBLAS_utest_src utest_main2.c)
else ()
  set(OpenBLAS_utest_src
    utest_main.c
    test_amax.c
    test_rotmg.c
    test_rot.c
    test_axpy.c
    test_dsdot.c
    test_swap.c
  )
endif ()

# crashing on travis cl with an error code suggesting resource not found
if (NOT MSVC)
set(OpenBLAS_utest_src
  ${OpenBLAS_utest_src}
  test_dotu.c
  )
endif ()

# known to hang with the native Windows and Android threads
# FIXME needs checking if this works on any of the other platforms
if (NOT USE_OPENMP)
if (OS_CYGWIN_NT OR OS_LINUX)
set(OpenBLAS_utest_src
  ${OpenBLAS_utest_src}
  test_fork.c
  )
endif()
endif()

if (NOT NO_LAPACK)
set(OpenBLAS_utest_src
  ${OpenBLAS_utest_src}
  test_potrs.c
  )
if (NOT NO_CBLAS AND NOT NO_LAPACKE)
set(OpenBLAS_utest_src
  ${OpenBLAS_utest_src}
  test_kernel_regress.c
  )
endif()
endif()

set(OpenBLAS_utest_bin openblas_utest)
add_executable(${OpenBLAS_utest_bin} ${OpenBLAS_utest_src})

target_link_libraries(${OpenBLAS_utest_bin} ${OpenBLAS_LIBNAME})

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
target_link_libraries(${OpenBLAS_utest_bin} m)
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "WindowsStore")
set_target_properties( ${OpenBLAS_utest_bin} PROPERTIES COMPILE_DEFINITIONS "_CRT_SECURE_NO_WARNINGS")
endif()

#Set output for utest
set_target_properties( ${OpenBLAS_utest_bin} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
  string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
  set_target_properties( ${OpenBLAS_utest_bin} PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_CURRENT_BINARY_DIR})
endforeach()

if (MSVC AND BUILD_SHARED_LIBS)
add_custom_command(TARGET ${OpenBLAS_utest_bin}
          POST_BUILD
          COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/lib/${CMAKE_CFG_INTDIR}/${OpenBLAS_LIBNAME}.dll ${CMAKE_CURRENT_BINARY_DIR}/.
)
endif()

add_test(${OpenBLAS_utest_bin} ${CMAKE_CURRENT_BINARY_DIR}/${OpenBLAS_utest_bin})

=== debian/changelog ===
openblas (0.3.8+ds-1) unstable; urgency=medium

  * New upstream version 0.3.8+ds
    + unfortunately we cannot enable dynamic arch for s390x, because it will
      not work correctly on pre-Z13 systems (there is no fallbak on
      ZARCH_GENERIC, see driver/other/dynamic_zarch.c)
  * d/copyright: reflect upstream changes
  * dgemm-test-without-lapacke.patch: drop patch, applied upstream
  * Remove spurious TARGET setting for ppc64el, which has dynamic arch
  * Bump S-V to 4.5.0
  * d/rules: do not run testsuite in override_dh_auto_build.
    It is already run in override_dh_auto_test.
    Also honour DEB_BUILD_OPTIONS=nocheck.
  * d/rules: ensure that whole build fails if build/test/install fails for one
    flavour
  * Remove unused override for libopenblas-dev
  * link-tests-openmp.patch: new patch, fixes build failure in OpenMP variants

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 13 Feb 2020 18:52:52 +0100

openblas (0.3.7+ds-7) unstable; urgency=medium

  * Fix (piuparts) install failure due to missing dir. (Closes: #946828)
  * Autopkgtest: print libopenblas{,64} selection before the test.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 18 Dec 2019 23:38:15 +0800

openblas (0.3.7+ds-6) unstable; urgency=medium

  * Restore pkgconfig’s openblas.pc (for 32-bit indexing)
    This file is now managed by the alternatives system, since there are several
    variants of it. (Closes: #946698)
    By the way, add openblas64.pc (for 64-bit indexing).
  * Fix alternatives symlink for openblas64_config.h (64-bit indexing variants)
  * Drop empty postrm script for libopenblas-dev
  * Make long description of libopenblas0 different from that of
    libopenblas64-0.
    Similar change for libopenblas-dev vs. libopenblas64-dev.
  * Fix the blas{,64}.pc and lapack{,64}.pc alternatives.
    For 32-bit indexing, the files pointed to an inexistent $libdir.
    The 64-bit indexing variants were pointing to 32-bit libraries.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 15 Dec 2019 22:02:19 +0100

openblas (0.3.7+ds-5) unstable; urgency=medium

  * Link the OMP variant of shared blas/lapack against gomp. (Closes: #945791)

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 02 Dec 2019 13:33:33 +0800

openblas (0.3.7+ds-4) unstable; urgency=medium

  * Don’t run the 64-bit autopkgtests on 32-bit architectures.
    Thanks to Matthias Klose (Closes: #944474)
  * Bump S-V to 4.4.1

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Nov 2019 17:49:02 +0100

openblas (0.3.7+ds-3) unstable; urgency=medium

  * Upload to unstable. (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 31 Oct 2019 20:46:13 +0800

openblas (0.3.7+ds-2) experimental; urgency=medium

  [ Multi-Flavour Update of OpenBLAS (Closes: #878121, #684344) ]
  * (32-bit, 64-bit)-index * (pthread, openmp, serial)-threadding = 6 Variants.
    Each one assigned with different priority values in alternatives system:
    + libopenblas0-{pthread,openmp,serial}    (priority = 100,95,90)
      * Provides: libopenblas.so.0, libblas.so.3, liblapack.so.3
    + libopenblas64-0-{pthread,openmp,serial} (priority = 100,95,90)
      * Provides: libopenblas64.so.0, libblas64.so.3, liblapack64.so.3
      - 64-bit-indexing versions are only available on 64-bit archs.
  * Let libopenblas0 and libopenblas64-0 be meta packages. They pull one of the
    three threadding variants. On resolving shlib dependencies, these meta
    packages, instead of specific variants used for building, should be used as
    the dependencies.
  * Turn libopenblas-base into a transitional dummy package.
  * Update/Create control files and maintscripts for all these variants.
  * Autopkgtest: test all the 6 variants.

  [ Mo Zhou ]
  * Append myself to Uploaders.
  * Simplify architecture detection part of rules.
  * Bump B-D lapack to >= 3.8.0-5 (for liblapack64-dev).
  * rules: Deparallelize build targets to avoid messy buildlog
  * Update existing patches accordingly for the new feature.
  * Merge order-files.patch into shared-blas-lapack.patch
  * Create template postrm for libopenblas-dev to avoid leftover.
  * Remove the unnecessary overrides from rules.
  * Upload to experimental.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 25 Oct 2019 21:03:40 +0800
